/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
// This file was generated by:
// CdlCompiler client -p.\buildtemp ..\..\..\..\uiresources_dom\cdl_api\inc\userpckg.cdl
// It contains the client API.
// It should not be modified manually.

#ifndef USERPCKG_CDL
#define USERPCKG_CDL

#include <CdlEngine.h>
#include <userpckg.cdl.common.h>

namespace CDL_User_Package
{

class CInstance;

// Standard interface functions 
inline void LoadCustomisationL(const TCdlRef& aRef)                          { CdlEngine::LoadCustomisationL(aRef); }
inline void LoadCustomisationL(const TDesC& aLibName, TInt aInstId)          { TCdlRef ref = { aInstId, { KCdlInterfaceUidValue }, &aLibName }; LoadCustomisationL(ref); }
inline void RequireCustomisationL()                                          { CdlEngine::RequireCustomisationL(&KCdlInterface); }
inline TBool IsCustomisationStarted()                                        { return CdlEngine::IsCustomisationStarted(&KCdlInterface); }
inline const CInstance& CustomisationInstance()                              { return (const CInstance&)(CdlEngine::CustomisationInstance(KCdlInterfaceUid)); }
inline void SetCustomisationChangeObserverL(MCdlChangeObserver* aObserver)   { CdlEngine::SetCustomisationChangeObserverL(aObserver, KCdlInterfaceUid); }

inline const TCdlRef& LastAccessedRef()                                      { return CdlEngine::LastAccessedRef(KCdlInterfaceUid); }
inline void FileNameRelativeToLastAccessedInstance(TFileName& aFileName)     { CdlEngine::FileNameRelativeToLastAccessedInstance(KCdlInterfaceUid, aFileName); }


// CDL API functions, as defined in userpckg.cdl

inline TDesC const& name()		{ return *(TDesC const*)(CdlEngine::GetData(KCdlInterfaceUid, EApiId_name)); }

inline TLanguage const& language()		{ return *(TLanguage const*)(CdlEngine::GetData(KCdlInterfaceUid, EApiId_language)); }

inline TUid const& uid()		{ return *(TUid const*)(CdlEngine::GetData(KCdlInterfaceUid, EApiId_uid)); }

inline TCdlArray<TCdlRef> const& contents()		{ return *(TCdlArray<TCdlRef> const*)(CdlEngine::GetData(KCdlInterfaceUid, EApiId_contents)); }



class CInstance : public CCdlInstance
	{
public:
	enum { ETypeId = KCdlInterfaceUidValue };

	inline static const CInstance& CustomisationInstance()                                                    { return (const CInstance&)(CdlEngine::CustomisationInstance(KCdlInterfaceUid)); }
	inline static CInstance* NewL(const TCdlRef& aRef, const CCdlInstance* aSubLayer = NULL)                  { return (CInstance*) CCdlInstance::NewL(aRef, &KCdlInterface, aSubLayer); }
	inline static CInstance* NewLC(const TCdlRef& aRef, const CCdlInstance* aSubLayer = NULL)                 { return (CInstance*) CCdlInstance::NewLC(aRef, &KCdlInterface, aSubLayer); }
	inline static CInstance* NewL(const TDesC& aLibName, TInt aImplId, const CCdlInstance* aSubLayer = NULL)  { TCdlRef ref = { aImplId, { KCdlInterfaceUidValue }, &aLibName }; return NewL(ref, aSubLayer); }
	inline static CInstance* NewLC(const TDesC& aLibName, TInt aImplId, const CCdlInstance* aSubLayer = NULL) { TCdlRef ref = { aImplId, { KCdlInterfaceUidValue }, &aLibName }; return NewLC(ref, aSubLayer); }

	inline const CInstance* SubLayer()                                                                        { return static_cast<const CInstance*>(CCdlInstance::SubLayer()); }

// CDL API functions, as defined in userpckg.cdl

	inline TDesC const& name() const		{ return *(TDesC const*)(GetData(EApiId_name)); }

	inline TLanguage const& language() const		{ return *(TLanguage const*)(GetData(EApiId_language)); }

	inline TUid const& uid() const		{ return *(TUid const*)(GetData(EApiId_uid)); }

	inline TCdlArray<TCdlRef> const& contents() const		{ return *(TCdlArray<TCdlRef> const*)(GetData(EApiId_contents)); }

private:
	CInstance();
	};

} // end of namespace CDL_User_Package
#endif // USERPCKG_CDL
